Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.1.0 E18814-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.tangosol.io
Class WrapperBufferInput

`java.lang.Object
com.tangosol.util.Base
com.tangosol.io.WrapperBufferInput`

All Implemented Interfaces:
  InputStreaming, ReadBuffer.BufferInput, java.io.DataInput

      public class WrapperBufferInput

extends Base
implements ReadBuffer.BufferInput

This is an imitation BufferInput implementation that provides the BufferInput interface by delegating to an object that implements the DataInput interface. Primarily, this is intended as a base class for building specific-purpose DataInput wrappers.

Author:
  jh 2007.11.17

Constructor Summary
`WrapperBufferInput(java.io.DataInput in)` Construct a WrapperBufferInput that will read from the specified object implementing the DataInput interface.
`WrapperBufferInput(java.io.DataInput in, ReadBuffer rb)` Construct a WrapperBufferInput that will read from the specified object implementing the DataInput interface and return the optional ReadBuffer as its underlying source.

Method Summary
`int` | `available()` Returns the number of bytes that can be read (or skipped over) from this input stream without causing a blocking I/O condition to occur.
`void` | `close()` Close the InputStream and release any system resources associated with it.
`ReadBuffer` | `getBuffer()` Get the ReadBuffer object that this BufferInput is reading from.
`java.io.DataInput` | `getDataInput()` Obtain the underlying object providing the DataInput interface that this object is delegating to.
`int` | `getOffset()` Determine the current offset of this BufferInput within the underlying ReadBuffer.
`void` | `mark(int cbReadLimit)` Marks the current read position in the InputStream in order to support the stream to be later "rewound" (using the `InputStreaming.reset()` method) to the current position.
`boolean` | `markSupported()` Determine if this InputStream supports the `InputStreaming.mark(int)` and `InputStreaming.reset()` methods.
`int` | `read()` Read the next byte of data from the InputStream.
`int` | `read(byte[] ab)` Read some number of bytes from the input stream and store them into the passed array `ab`.
`int` | `read(byte[] ab, int of, int cb)` Read up to `cb` bytes from the input stream and store them into the passed array `ab` starting at offset `of`.
`boolean` | `readBoolean()` Read a boolean value.
`ReadBuffer` | `readBuffer(int cb)` Read `cb` bytes and return them as a ReadBuffer object.
`byte` | `readByte()` Read a byte value.
`char` | `readChar()` Read a char value.
`double` | `readDouble()` Read a double value.
`float` | `readFloat()` Read a float value.
`void` | `readFully(byte[] ab)` Read `ab.length` bytes and store them in `ab`.
`void` | `readFully(byte[] ab, int of, int cb)` Read `cb` bytes and store them in `ab` starting at offset `of`.
`int` | `readInt()` Read an int value.
`java.lang.String` | `readLine()` Reads the next "line" of text.
`long` | `readLong()` Read a long value.
`int` | `readPackedInt()` Read an int value using a variable-length storage format as described by `WriteBuffer.BufferOutput.writePackedInt(int)`.
`long` | `readPackedLong()` Read a long value using a variable-length storage format as described by `WriteBuffer.BufferOutput.writePackedLong(long)`.
`java.lang.String` | `readSafeUTF()` Read a variable-length encoded UTF packed String.
`short` | `readShort()` Read a short value.
`int` | `readUnsignedByte()` Read an unsigned byte value.
`int` | `readUnsignedShort()` Read an unsigned short value.
`java.lang.String` | `readUTF()` Reads a String value.
`void` | `reset()` Rewind this stream to the position at the time the `InputStreaming.mark(int)` method was last called on this InputStream.
`void` | `setOffset(int of)` Specify the offset of the next byte to read from the underlying ReadBuffer.
`long` | `skip(long cb)` Skips over up to the specified number of bytes of data from this InputStream.
`int` | `skipBytes(int cb)` Skips over up to the specified number of bytes of data.

Constructor Detail

### WrapperBufferInput

    public WrapperBufferInput(java.io.DataInput in)

  Construct a WrapperBufferInput that will read from the specified object implementing the DataInput interface.
  Parameters:
    `in` - an object implementing DataInput to read from

### WrapperBufferInput

    public WrapperBufferInput(java.io.DataInput in,
                              ReadBuffer rb)

  Construct a WrapperBufferInput that will read from the specified object implementing the DataInput interface and return the optional ReadBuffer as its underlying source.
  Parameters:
    `in` - an object implementing DataInput to read from
    `rb` - an optional object implementing ReadBuffer

Method Detail

### read

    public int read()
             throws java.io.IOException

  Read the next byte of data from the InputStream. The value byte is returned as an `int` in the range `0` to `255`. If the end of the stream has been reached, the value `-1` is returned.

  This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.

  Specified by:
    `read` in interface `InputStreaming`
  Returns:
    the next byte of data, or `-1` if the end of the stream has been reached
  Throws:
    `java.io.IOException` - if an I/O error occurs

### read

    public int read(byte[] ab)
             throws java.io.IOException

  Read some number of bytes from the input stream and store them into the passed array `ab`. The number of bytes actually read is returned.

  This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.

  Specified by:
    `read` in interface `InputStreaming`
  Parameters:
    `ab` - the array to store the bytes which are read from the stream
  Returns:
    the number of bytes read from the stream, or `-1` if no bytes were read from the stream because the end of the stream had been reached
  Throws:
    `java.io.IOException` - if an I/O error occurs

### read

    public int read(byte[] ab,
                    int of,
                    int cb)
             throws java.io.IOException

  Read up to `cb` bytes from the input stream and store them into the passed array `ab` starting at offset `of`. The number of bytes actually read is returned.

  This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.

  Specified by:
    `read` in interface `InputStreaming`
  Parameters:
    `ab` - the array to store the bytes which are read from the stream
    `of` - the offset into the array that the read bytes will be stored
    `cb` - the maximum number of bytes to read
  Returns:
    the number of bytes read from the stream, or `-1` if no bytes were read from the stream because the end of the stream had been reached
  Throws:
    `java.io.IOException` - if an I/O error occurs

### skip

    public long skip(long cb)
              throws java.io.IOException

  Skips over up to the specified number of bytes of data from this InputStream. The number of bytes actually skipped over may be fewer than the number specified to skip, and may even be zero; this can be caused by an end-of-file condition, but can also occur even when there is data remaining in the InputStream. As a result, the caller should check the return value from this method, which indicates the actual number of bytes skipped.
  Specified by:
    `skip` in interface `InputStreaming`
  Parameters:
    `cb` - the maximum number of bytes to skip over
  Returns:
    the actual number of bytes that were skipped over
  Throws:
    `java.io.IOException` - if an I/O error occurs

### available

    public int available()
                  throws java.io.IOException

  Returns the number of bytes that can be read (or skipped over) from this input stream without causing a blocking I/O condition to occur. This method reflects the assumed implementation of various buffering InputStreams, which can guarantee non-blocking reads up to the extent of their buffers, but beyond that the read operations will have to read from some underlying (and potentially blocking) source.
  Specified by:
    `available` in interface `InputStreaming`
  Specified by:
    `available` in interface `ReadBuffer.BufferInput`
  Returns:
    the number of bytes that can be read from this InputStream without blocking
  Throws:
    `java.io.IOException` - if an I/O error occurs

### close

    public void close()
               throws java.io.IOException

  Close the InputStream and release any system resources associated with it.
  Specified by:
    `close` in interface `InputStreaming`
  Specified by:
    `close` in interface `ReadBuffer.BufferInput`
  Throws:
    `java.io.IOException` - if an I/O error occurs

### mark

    public void mark(int cbReadLimit)

  Marks the current read position in the InputStream in order to support the stream to be later "rewound" (using the `InputStreaming.reset()` method) to the current position. The caller passes in the maximum number of bytes that it expects to read before calling the `InputStreaming.reset()` method, thus indicating the upper bounds of the responsibility of the stream to be able to buffer what it has read in order to support this functionality.
  Specified by:
    `mark` in interface `InputStreaming`
  Specified by:
    `mark` in interface `ReadBuffer.BufferInput`
  Parameters:
    `cbReadLimit` - the maximum number of bytes that caller expects the InputStream to be able to read before the mark position becomes invalid

### reset

    public void reset()
               throws java.io.IOException

  Rewind this stream to the position at the time the `InputStreaming.mark(int)` method was last called on this InputStream. If the InputStream cannot fulfill this contract, it should throw an IOException.
  Specified by:
    `reset` in interface `InputStreaming`
  Throws:
    `java.io.IOException` - if an I/O error occurs, for example if this has not been marked or if the mark has been invalidated

### markSupported

    public boolean markSupported()

  Determine if this InputStream supports the `InputStreaming.mark(int)` and `InputStreaming.reset()` methods.
  Specified by:
    `markSupported` in interface `InputStreaming`
  Specified by:
    `markSupported` in interface `ReadBuffer.BufferInput`
  Returns:
    `true` if this InputStream supports the mark and reset method; `false` otherwise

### readFully

    public void readFully(byte[] ab)
                   throws java.io.IOException

  Read `ab.length` bytes and store them in `ab`.

  This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.

  Specified by:
    `readFully` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readFully` in interface `java.io.DataInput`
  Parameters:
    `ab` - the array to store the bytes which are read from the stream
  Throws:
    `java.io.EOFException` - if the stream is exhausted before the number of bytes indicated by the array length could be read
    `java.io.IOException` - if an I/O error occurs

### readFully

    public void readFully(byte[] ab,
                          int of,
                          int cb)
                   throws java.io.IOException

  Read `cb` bytes and store them in `ab` starting at offset `of`.

  This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.

  Specified by:
    `readFully` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readFully` in interface `java.io.DataInput`
  Parameters:
    `ab` - the array to store the bytes which are read from the stream
    `of` - the offset into the array that the read bytes will be stored
    `cb` - the maximum number of bytes to read
  Throws:
    `java.io.EOFException` - if the stream is exhausted before the number of bytes indicated by the array length could be read
    `java.io.IOException` - if an I/O error occurs

### skipBytes

    public int skipBytes(int cb)
                  throws java.io.IOException

  Skips over up to the specified number of bytes of data. The number of bytes actually skipped over may be fewer than the number specified to skip, and may even be zero; this can be caused by an end-of-file condition, but can also occur even when there is data remaining to be read. As a result, the caller should check the return value from this method, which indicates the actual number of bytes skipped.
  Specified by:
    `skipBytes` in interface `ReadBuffer.BufferInput`
  Specified by:
    `skipBytes` in interface `java.io.DataInput`
  Parameters:
    `cb` - the maximum number of bytes to skip over
  Returns:
    the actual number of bytes that were skipped over
  Throws:
    `java.io.IOException` - if an I/O error occurs

### readBoolean

    public boolean readBoolean()
                        throws java.io.IOException

  Read a boolean value.

  This method is the counterpart for the `DataOutput.writeBoolean(boolean)` method.

  Specified by:
    `readBoolean` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readBoolean` in interface `java.io.DataInput`
  Returns:
    either `true` or `false`
  Throws:
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### readByte

    public byte readByte()
                  throws java.io.IOException

  Read a byte value.

  This method is the counterpart for the `DataOutput.writeByte(int)` method.

  Specified by:
    `readByte` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readByte` in interface `java.io.DataInput`
  Returns:
    a `byte` value
  Throws:
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### readUnsignedByte

    public int readUnsignedByte()
                         throws java.io.IOException

  Read an unsigned byte value.

  This method is the counterpart for the `DataOutput.writeByte(int)` method when it is used with unsigned 8-bit values.

  Specified by:
    `readUnsignedByte` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readUnsignedByte` in interface `java.io.DataInput`
  Returns:
    an `int` value in the range 0x00 to 0xFF
  Throws:
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### readShort

    public short readShort()
                    throws java.io.IOException

  Read a short value.

  This method is the counterpart for the `DataOutput.writeShort(int)` method.

  Specified by:
    `readShort` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readShort` in interface `java.io.DataInput`
  Returns:
    a `short` value
  Throws:
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### readUnsignedShort

    public int readUnsignedShort()
                          throws java.io.IOException

  Read an unsigned short value.

  This method is the counterpart for the `DataOutput.writeShort(int)` method when it is used with unsigned 16-bit values.

  Specified by:
    `readUnsignedShort` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readUnsignedShort` in interface `java.io.DataInput`
  Returns:
    an `int` value in the range of 0x0000 to 0xFFFF
  Throws:
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### readChar

    public char readChar()
                  throws java.io.IOException

  Read a char value.

  This method is the counterpart for the `DataOutput.writeChar(int)` method.

  Specified by:
    `readChar` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readChar` in interface `java.io.DataInput`
  Returns:
    a `char` value
  Throws:
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### readInt

    public int readInt()
                throws java.io.IOException

  Read an int value.

  This method is the counterpart for the `DataOutput.writeInt(int)` method.

  Specified by:
    `readInt` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readInt` in interface `java.io.DataInput`
  Returns:
    an `int` value
  Throws:
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### readLong

    public long readLong()
                  throws java.io.IOException

  Read a long value.

  This method is the counterpart for the `DataOutput.writeLong(long)` method.

  Specified by:
    `readLong` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readLong` in interface `java.io.DataInput`
  Returns:
    a `long` value
  Throws:
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### readFloat

    public float readFloat()
                    throws java.io.IOException

  Read a float value.

  This method is the counterpart for the `DataOutput.writeFloat(float)` method.

  Specified by:
    `readFloat` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readFloat` in interface `java.io.DataInput`
  Returns:
    a `float` value
  Throws:
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### readDouble

    public double readDouble()
                      throws java.io.IOException

  Read a double value.

  This method is the counterpart for the `DataOutput.writeDouble(double)` method.

  Specified by:
    `readDouble` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readDouble` in interface `java.io.DataInput`
  Returns:
    a `double` value
  Throws:
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### readLine

    public java.lang.String readLine()
                              throws java.io.IOException

  Reads the next "line" of text.

  This method does not have a counterpart in the `DataOutput` interface. Furthermore, this method is defined as operating on bytes and not on characters, and thus it should be selected for use only after careful consideration, as if it were deprecated (which it has been in java.io.DataInputStream).

  Specified by:
    `readLine` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readLine` in interface `java.io.DataInput`
  Returns:
    a line of text as a String
  Throws:
    `java.io.IOException` - if an I/O error occurs.

### readUTF

    public java.lang.String readUTF()
                             throws java.io.IOException

  Reads a String value.

  This method is the counterpart for the `DataOutput.writeUTF(java.lang.String)` method.

  Specified by:
    `readUTF` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readUTF` in interface `java.io.DataInput`
  Returns:
    a String value
  Throws:
    `java.io.UTFDataFormatException` - if the bytes that were read were not a valid UTF-8 encoded string
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### getBuffer

    public ReadBuffer getBuffer()

  Get the ReadBuffer object that this BufferInput is reading from.
  Specified by:
    `getBuffer` in interface `ReadBuffer.BufferInput`
  Returns:
    the underlying ReadBuffer object

### readSafeUTF

    public java.lang.String readSafeUTF()
                                 throws java.io.IOException

  Read a variable-length encoded UTF packed String. The major differences between this implementation and DataInput is that this supports null String values and is not limited to 64KB UTF-encoded values.
  Specified by:
    `readSafeUTF` in interface `ReadBuffer.BufferInput`
  Returns:
    a String value; may be null
  Throws:
    `java.io.IOException` - if an I/O error occurs

### readPackedInt

    public int readPackedInt()
                      throws java.io.IOException

  Read an int value using a variable-length storage format as described by `WriteBuffer.BufferOutput.writePackedInt(int)`.
  Specified by:
    `readPackedInt` in interface `ReadBuffer.BufferInput`
  Returns:
    an int value
  Throws:
    `java.io.IOException` - if an I/O error occurs

### readPackedLong

    public long readPackedLong()
                        throws java.io.IOException

  Read a long value using a variable-length storage format as described by `WriteBuffer.BufferOutput.writePackedLong(long)`.
  Specified by:
    `readPackedLong` in interface `ReadBuffer.BufferInput`
  Returns:
    a long value
  Throws:
    `java.io.IOException` - if an I/O error occurs

### readBuffer

    public ReadBuffer readBuffer(int cb)
                          throws java.io.IOException

  Read `cb` bytes and return them as a ReadBuffer object.
  Specified by:
    `readBuffer` in interface `ReadBuffer.BufferInput`
  Parameters:
    `cb` - the number of bytes to read
  Returns:
    a ReadBuffer object composed of `cb` bytes read from the BufferInput
  Throws:
    `java.io.EOFException` - if the stream is exhausted before the number of bytes indicated could be read
    `java.io.IOException` - if an I/O error occurs

### getOffset

    public int getOffset()

  Determine the current offset of this BufferInput within the underlying ReadBuffer.
  Specified by:
    `getOffset` in interface `ReadBuffer.BufferInput`
  Returns:
    the offset of the next byte to read from the ReadBuffer

### setOffset

    public void setOffset(int of)

  Specify the offset of the next byte to read from the underlying ReadBuffer.
  Specified by:
    `setOffset` in interface `ReadBuffer.BufferInput`
  Parameters:
    `of` - the offset of the next byte to read from the ReadBuffer

### getDataInput

    public java.io.DataInput getDataInput()

  Obtain the underlying object providing the DataInput interface that this object is delegating to.
  Returns:
    the underlying DataInput

Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.1.0 E18814-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.